from typing import Any, Dict, List, Type, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

T = TypeVar("T", bound="RtCreateBody")


@_attrs_define
class RtCreateBody:
    """
    Attributes:
        leaderboard_id (str):
        request_type (int): (0 = unrank, 1 rank)
        description (str):
    """

    leaderboard_id: str
    request_type: int
    description: str
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        leaderboard_id = self.leaderboard_id

        request_type = self.request_type

        description = self.description

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "leaderboardId": leaderboard_id,
                "requestType": request_type,
                "description": description,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        leaderboard_id = d.pop("leaderboardId")

        request_type = d.pop("requestType")

        description = d.pop("description")

        rt_create_body = cls(
            leaderboard_id=leaderboard_id,
            request_type=request_type,
            description=description,
        )

        rt_create_body.additional_properties = d
        return rt_create_body

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
